// Fill out your copyright notice in the Description page of Project Settings.

#include "TheracAdapterComponent.h"
#include "HAL/PlatformProcess.h"
#include "Interfaces/IPluginManager.h"
#include "Misc/Paths.h"
#include <Internationalization/Internationalization.h>
#include <Internationalization/Text.h>
#include <Misc/MessageDialog.h>
#include <Therac.h>
#include <map>
#include <Logging/StructuredLog.h>

#define LOCTEXT_NAMESPACE "TheracAdapter"

// Sets default values for this component's properties
UTheracAdapterComponent::UTheracAdapterComponent() {
  // Set this component to be initialized when the game starts, and to be ticked
  // every frame.  You can turn these features off to improve performance if you
  // don't need them.
  PrimaryComponentTick.bCanEverTick = true;

  // ...
}

// Called when the game starts
void UTheracAdapterComponent::BeginPlay() {
  /*
  FString BaseDir =
      IPluginManager::Get().FindPlugin("hstherac25")->GetBaseDir();
  FString LibraryPath =
      FPaths::Combine(*BaseDir, TEXT("Source/hstherac-hs/HSdll.dll"));

  auto simulatorLibraryHandle =
      !LibraryPath.IsEmpty() ? FPlatformProcess::GetDllHandle(*LibraryPath)
                             : nullptr;
                             */
  Super::BeginPlay();
  wrappedComms                            = start_machine();
  std::map<FText *, StateInfoRequest> hng = {
      {&TreatmentOutcome, RequestTreatmentOutcome},
      {&ActiveSubsystem, RequestActiveSubsystem},
      {&TreatmentState, RequestTreatmentState},
      {&Reason, RequestReason},
      {&BeamMode, RequestBeamMode},
      {&BeamEnergy, RequestBeamEnergy}
  };
  for (auto & [hnng, hnnng] : hng) {
    compMap.Add(hnng, hnnng);
  }
  // ...
}

// Called every frame
void UTheracAdapterComponent::TickComponent(
    float DeltaTime,
    ELevelTick TickType,
    FActorComponentTickFunction * ThisTickFunction
) {
  Super::TickComponent(DeltaTime, TickType, ThisTickFunction);

  auto rsi = [&](FText * f) {
    return FText::FromString(
        StaticCast<char *>(request_state_info(wrappedComms, *compMap.Find(f)))
    );
  };

  for (auto & [f, _] : compMap) {
    //    UE_LOGFMT(LogTemp, Warning, "what {dildo}", rsi(f).ToString());
    *f = rsi(f);
  }
}

